/*================================================================================================================*/
// ************************************ THESE ARE THE INFORMATIONS OF THE MAP: ********************************** //
/*================================================================================================================*/
// THE ALAMO:
// CREATED BY DANY:
// FEBRUARY 2207:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Comanche");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Comanche");

		subCiv1=rmGetCivID("Comanche");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Comanche"); 

		subCiv2=rmGetCivID("Comanche");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Comanche");

		subCiv3=rmGetCivID("Comanche");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Comanche");	
   }		
/*================================================================================================================*/   
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
	int playerTiles=30000;
	
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
/*================================================================================================================*/	
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** // 
/*================================================================================================================*/
	// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	rmSetMapElevationHeightBlend(1);
	
	// Picks a default water height
	rmSetSeaLevel(4.0);
	rmSetLightingSet("Texas");

   // Picks default terrain and water
	rmSetSeaType("Amazon River");
	rmSetBaseTerrainMix("texas_grass");
	rmTerrainInitialize("texas\ground1_tex", 5.0);
	rmSetMapType("texas");
	rmSetMapType("grass");
	rmSetMapType("land");

	// Corner constraint.
	rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("nuggets");
	    rmDefineClass("center");
	    rmDefineClass("classCotton");
		rmDefineClass("regions");
		rmDefineClass("regions2");
        //rmDefineClass("berrybush");
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
   
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
	int bisonEdgeConstraint=rmCreateBoxConstraint("bison edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	// int goldCenterConstraint=rmCreateBoxConstraint("gold keeps away from middle", 0.2, 0.2, 0.8, 0.8, 0.01);
	int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
	int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 60.0);

   // Cardinal Directions
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

	// BONUS AREA CONSTRAINT:
    //int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);
	int regionConstraint=rmCreateClassDistanceConstraint("region avoid region", rmClassID("regions"), 20.0);
    int avoidRegion=rmCreateClassDistanceConstraint("stuff avoid region", rmClassID("regions"), 10.0);
	int region2Constraint=rmCreateClassDistanceConstraint("region2 avoid region2", rmClassID("regions2"), 20.0);
    int avoidRegion2=rmCreateClassDistanceConstraint("stuff avoid region2", rmClassID("regions2"), 10.0);
    
 
	
	// Nature avoidance
	// int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
	// int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);

	// Coin constraint drops on smaller maps.
	int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	if ( cNumberNonGaiaPlayers < 4 )
	{
		coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin small maps", "gold", 25.0);
	}

	int cottonConstraint=rmCreateClassDistanceConstraint("cotton constraint", rmClassID("classCotton"), 30.0);
	int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   
   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
   int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
   int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 14.0);
	int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);

   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
   int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
        
	// NATIVES AVOIDANCE:	
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 20.0);
	int avoidFarNatives=rmCreateClassDistanceConstraint("stuff avoids natives from far", rmClassID("natives"), 50.0);
	
	// GOLD AVOIDANCE:
	int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 15.0);
	int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 45.0);
	
	// BISON AVOIDANCE:
	int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 15.0);
	int bisonAvoidBison=rmCreateTypeDistanceConstraint("bison avoids bison", "bison", 25.0);
	
	// DEER AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
	int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 25.0);
	
	// FRUIT AVOIDANCE:
	int avoidFruit=rmCreateTypeDistanceConstraint("stuff avoids fruit", "berrybush", 10.0);
	int fruitAvoidFruit=rmCreateTypeDistanceConstraint("fruit avoids fruit", "berrybush", 15.0);
	   
	
	int avoidSecrets=rmCreateClassDistanceConstraint("stuff avoids secrets", rmClassID("secrets"), 20.0);
	
	int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 5.0);
	int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nuggets avoids nuggets", rmClassID("nuggets"), 15.0);
	
	
	int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
	int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 50.0);
	
	
	int forestsAvoidBison=rmCreateTypeDistanceConstraint("forest avoids bison", "bison", 20.0);

	 int avoidOutpost=rmCreateTypeDistanceConstraint("outposts avoid outposts", "Outpost", 24.0);
	 int avoidOutpostBarracks=rmCreateTypeDistanceConstraint("barracks avoid outposts", "Outpost", 24.0);
	 int avoidBlockhouse=rmCreateTypeDistanceConstraint("blockhouses avoid blockhouses", "Blockhouse", 35.0);

	// Decoration avoidance
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	// Trade route avoidance.
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
	int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);

	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
// ******************************************* DEFINE THE OBJECTS: ********************************************** //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*================================================================================================================*/
   int bisonID=rmCreateObjectDef("bison herd center");
   rmAddObjectDefItem(bisonID, "bison", rmRandInt(8,10), 6.0);
   rmSetObjectDefMinDistance(bisonID, 0.0);
   rmSetObjectDefMaxDistance(bisonID, 5.0);

   // wood resources
   int randomTreeID=rmCreateObjectDef("random tree");
   rmAddObjectDefItem(randomTreeID, "TreeTexasDirt", 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0);
   rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, avoidResource);
   rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);

   // starting resources
	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);

	int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	rmSetObjectDefMinDistance(StartPronghornID, 5);
	rmSetObjectDefMaxDistance(StartPronghornID, 12);
	rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	rmAddObjectDefConstraint(StartPronghornID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(StartPronghornID, avoidNatives);
	rmSetObjectDefCreateHerd(StartPronghornID, true);
/*================================================================================================================*/
// ************************************** THIS IS DONE DEFINING OBJECTS: **************************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.75,0.75);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.250,0.250);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //		
/*================================================================================================================*/
        // FLOAT THE PLAYER FRACTION:
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        // SET THE MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        // ADD AREA CONSTRAINTS:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        // SET AREA LOCATION PLAYER:
		rmSetAreaLocPlayer(id, i);
		// SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "texas\ground2");
        // SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD ALL THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/ 
// ************************************* DEFINE AND PLACE THE REGION E1: **************************************** //
/*================================================================================================================*/
        int smallRegionE1ID=rmCreateArea("Small Region E1");
        //rmSetAreaSize(smallRegionE1ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE1ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE1ID, 40);
		rmAddAreaToClass(smallRegionE1ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE1ID, regionConstraint);
        rmSetAreaMix(smallRegionE1ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionE1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE1ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE1ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE1ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionE1ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE1ID, 3);
        rmSetAreaElevationPersistence(smallRegionE1ID, 0.5); 
        rmSetAreaCoherence(smallRegionE1ID, 0.65);
		rmSetAreaLocation(smallRegionE1ID, 0.90, 0.55);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE1ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE1ID);   
/*================================================================================================================*/ 
// ************************************* DEFINE AND PLACE THE REGION E2: **************************************** //
/*================================================================================================================*/
        int smallRegionE2ID=rmCreateArea("Small Region E2");
        //rmSetAreaSize(smallRegionE2ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE2ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE2ID, 40);
		rmAddAreaToClass(smallRegionE2ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE2ID, regionConstraint);
        rmSetAreaMix(smallRegionE2ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionE2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE2ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE2ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE2ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionE2ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE2ID, 3);
        rmSetAreaElevationPersistence(smallRegionE2ID, 0.5); 
        rmSetAreaCoherence(smallRegionE2ID, 0.65);
		rmSetAreaLocation(smallRegionE2ID, 0.85, 0.35);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE2ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE2ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION E3: **************************************** //
/*================================================================================================================*/
        int smallRegionE3ID=rmCreateArea("Small Region E3");
        //rmSetAreaSize(smallRegionE3ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE3ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE3ID, 40);
		rmAddAreaToClass(smallRegionE3ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE3ID, regionConstraint);
        rmSetAreaMix(smallRegionE3ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionE3ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE3ID, 2.0);
        //rmSetAreaBaseHeight(smallRegion3ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE3ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionE3ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE3ID, 3);
        rmSetAreaElevationPersistence(smallRegionE3ID, 0.5); 
        rmSetAreaCoherence(smallRegionE3ID, 0.65);
		rmSetAreaLocation(smallRegionE3ID, 0.7, 0.2);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE3ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE3ID);	
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION E4: **************************************** //
/*================================================================================================================*/
        int smallRegionE4ID=rmCreateArea("Small Region E4");
        //rmSetAreaSize(smallRegionE4ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionE4ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionE4ID, 40);
		rmAddAreaToClass(smallRegionE4ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionE4ID, regionConstraint);
        rmSetAreaMix(smallRegionE4ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionE4ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionE4ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionE4ID, 1.0);
		rmSetAreaBaseHeight(smallRegionE4ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionE4ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionE4ID, 3);
        rmSetAreaElevationPersistence(smallRegionE4ID, 0.5); 
        rmSetAreaCoherence(smallRegionE4ID, 0.65);
		rmSetAreaLocation(smallRegionE4ID, 0.5, 0.15);
		rmSetAreaObeyWorldCircleConstraint(smallRegionE4ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionE4ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION W1: **************************************** //
/*================================================================================================================*/
        int smallRegionW1ID=rmCreateArea("Small Region W1");
        //rmSetAreaSize(smallRegionW1ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionW1ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionW1ID, 40);
		rmAddAreaToClass(smallRegionW1ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionW1ID, regionConstraint);
        rmSetAreaMix(smallRegionW1ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionW1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionW1ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionW1ID, 1.0);
		rmSetAreaBaseHeight(smallRegionW1ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionW1ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionW1ID, 3);
        rmSetAreaElevationPersistence(smallRegionW1ID, 0.5); 
        rmSetAreaCoherence(smallRegionW1ID, 0.65);
		rmSetAreaLocation(smallRegionW1ID, 0.55, 0.90);
		rmSetAreaObeyWorldCircleConstraint(smallRegionW1ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionW1ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION W2: **************************************** //
/*================================================================================================================*/
        int smallRegionW2ID=rmCreateArea("Small Region W2");
        //rmSetAreaSize(smallRegionW2ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionW2ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionW2ID, 40);
		rmAddAreaToClass(smallRegionW2ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionW2ID, regionConstraint);
        rmSetAreaMix(smallRegionW2ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionW2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionW2ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionW2ID, 1.0);
		rmSetAreaBaseHeight(smallRegionW2ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionW2ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionW2ID, 3);
        rmSetAreaElevationPersistence(smallRegionW2ID, 0.5); 
        rmSetAreaCoherence(smallRegionW2ID, 0.65);
		rmSetAreaLocation(smallRegionW2ID, 0.35, 0.85);
		rmSetAreaObeyWorldCircleConstraint(smallRegionW2ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionW2ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION W3: **************************************** //
/*================================================================================================================*/
        int smallRegionW3ID=rmCreateArea("Small Region W3");
        //rmSetAreaSize(smallRegionW3ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionW3ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionW3ID, 40);
		rmAddAreaToClass(smallRegionW3ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionW3ID, regionConstraint);
        rmSetAreaMix(smallRegionW3ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionW3ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionW3ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionW3ID, 1.0);
		rmSetAreaBaseHeight(smallRegionW3ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionW3ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionW3ID, 3);
        rmSetAreaElevationPersistence(smallRegionW3ID, 0.5); 
        rmSetAreaCoherence(smallRegionW3ID, 0.65);
		rmSetAreaLocation(smallRegionW3ID, 0.20, 0.70);
		rmSetAreaObeyWorldCircleConstraint(smallRegionW3ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionW3ID);
/*================================================================================================================*/		
// ************************************* DEFINE AND PLACE THE REGION W4: **************************************** //
/*================================================================================================================*/
        int smallRegionW4ID=rmCreateArea("Small Region W4");
        //rmSetAreaSize(smallRegionW4ID, 0.41, 0.42);	
        rmSetAreaSize(smallRegionW4ID, 0.02, 0.02);			
        rmSetAreaSmoothDistance(smallRegionW4ID, 40);
		rmAddAreaToClass(smallRegionW4ID, rmClassID("regions"));
        rmAddAreaConstraint(smallRegionW4ID, regionConstraint);
        rmSetAreaMix(smallRegionW4ID, "texas_dirt");
        rmSetAreaElevationType(smallRegionW4ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallRegionW4ID, 2.0);
        //rmSetAreaBaseHeight(smallRegionW4ID, 1.0);
		rmSetAreaBaseHeight(smallRegionW4ID, 6.0);
        rmSetAreaElevationMinFrequency(smallRegionW4ID, 0.09);
        rmSetAreaElevationOctaves(smallRegionW4ID, 3);
        rmSetAreaElevationPersistence(smallRegionW4ID, 0.5); 
        rmSetAreaCoherence(smallRegionW4ID, 0.65);
		rmSetAreaLocation(smallRegionW4ID, 0.15, 0.50);
		rmSetAreaObeyWorldCircleConstraint(smallRegionW4ID, false);//( it put the island near the edge of the map )
        rmBuildArea(smallRegionW4ID);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
 	// Placement order
	// Trade Route -> Players and player stuff -> Natives -> Secrets -> Cliffs -> Nuggets
	// Place other objects that were defined earlier
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************** DEFINE THE TCID AND THE STARTING UNITS AND RESOURCES: ***************************** //
/*================================================================================================================*/
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
		// Give it a little wiggle room for maps with greater than four players
		if ( cNumberNonGaiaPlayers > 4 )
		{
			rmSetObjectDefMinDistance(startingTCID, 0.0);
			rmSetObjectDefMaxDistance(startingTCID, 6.0);
		}
	}

	int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
	
   int playerBisonID=rmCreateObjectDef("player bison herd");
   rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
   rmSetObjectDefMinDistance(playerBisonID, 40.0);
   rmSetObjectDefMaxDistance(playerBisonID, 45.0);
	rmAddObjectDefConstraint(playerBisonID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerBisonID, avoidImportantItem);
	rmSetObjectDefCreateHerd(playerBisonID, true);

	int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteCliff);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	// rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

    int playerGoldID=rmCreateObjectDef("player silver ore");
	int silverType = rmRandInt(1,10);
/*================================================================================================================*/
// ************************************** THIS IS THE PLAYER PLACEMENT: ***************************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		
		
		// Place starting units and a TC!
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Place extra buildings, unless nomad start.
		if ( rmGetNomadStart() == false )
	
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Place starting resources - DAL
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two ore groupings, one pretty close, the other a little further away.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 40.0);
		rmSetObjectDefMaxDistance(playerGoldID, 50.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two bison herds..
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Player nuggets.
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************** DEFINE SOME NECESSAY VARIABLES: *************************************** //
/*================================================================================================================*/

	// Text
	int numTries = -1;
	int failCount = -1;
	
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE CENTRAL POND: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*        int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 10.0);
		int avoidPond=rmCreateClassDistanceConstraint("stuff avoid the pond", rmClassID("pond"), 10.0);
        int smallPondID=rmCreateArea("small pond");
	
	
		// rmSetAreaSize(smallPondID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		   rmSetAreaSize(smallPondID, 0.05, 0.05);
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 3);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		//THOSE 4 INFLUENCE POINTS MAKE A REGION WITH A SQUARE SHAPE:
		//rmAddAreaInfluencePoint(smallPondID, 0.4, 0.4); // ADDED BY ME:
		//rmAddAreaInfluencePoint(smallPondID, 0.4, 0.5); // ADDED BY ME:
		//rmAddAreaInfluencePoint(smallPondID, 0.4, 0.6); // ADDED BY ME:
	    //rmAddAreaInfluencePoint(smallPondID, 0.5, 0.6); // ADDED BY ME:
		//rmAddAreaInfluencePoint(smallPondID, 0.6, 0.6); // ADDED BY ME:
		//rmAddAreaInfluencePoint(smallPondID, 0.6, 0.5); // ADDED BY ME:
		//rmAddAreaInfluencePoint(smallPondID, 0.6, 0.4); // ADDED BY ME:
	    //rmAddAreaInfluencePoint(smallPondID, 0.5, 0.4); // ADDED BY ME:
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 40);
		rmAddAreaConstraint(smallPondID, playerConstraint);
		rmAddAreaConstraint(smallPondID, avoidFarNatives);
		rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaObeyWorldCircleConstraint(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID); */
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE REGION CENTER: *************************************** //
/*================================================================================================================*/
        int centerRegionID=rmCreateArea("The Center Region");
        //rmSetAreaSize(centerRegionID, 0.41, 0.42);	
        rmSetAreaSize(centerRegionID, 0.05, 0.05);			
        rmSetAreaSmoothDistance(centerRegionID, 40);
		rmAddAreaToClass(centerRegionID, rmClassID("regions2"));
        rmAddAreaConstraint(centerRegionID, avoidRegion2);
		rmAddAreaConstraint(centerRegionID, region2Constraint);
        rmSetAreaMix(centerRegionID, "texas_dirt");
        rmSetAreaElevationType(centerRegionID, cElevTurbulence);
        rmSetAreaElevationVariation(centerRegionID, 2.0);
        //rmSetAreaBaseHeight(centerRegionID, 1.0);
		rmSetAreaBaseHeight(centerRegionID, 6.0);
        rmSetAreaElevationMinFrequency(centerRegionID, 0.09);
        rmSetAreaElevationOctaves(centerRegionID, 3);
        rmSetAreaElevationPersistence(centerRegionID, 0.5); 
        rmSetAreaCoherence(centerRegionID, 0.65);
		rmSetAreaLocation(centerRegionID, 0.50, 0.50);
		rmSetAreaObeyWorldCircleConstraint(centerRegionID, false);//( it put the island near the edge of the map )
        //rmBuildArea(centerRegionID);
        rmBuildArea(centerRegionID);		
/*================================================================================================================*/		
/*================================================================================================================*/ 
// ********************* DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ********************* //
/*===============================================================================================================-*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comancheVillageID = -1;
		comancheVillageID = rmCreateGrouping("comanche village", "native comanche village 1");
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		//rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comancheVillageID, avoidNatives);
		//rmAddGroupingConstraint(comancheVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.45, 0.25);
	} 

	    if (subCiv1 == rmGetCivID("Comanche"))
	{  
		int comanche2VillageID = -1;
		comanche2VillageID = rmCreateGrouping("comanche village 2", "native comanche village 1");
		rmSetGroupingMinDistance(comanche2VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche2VillageID, 0.0);
		// rmAddGroupingConstraint(comanche2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(comanche2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche2VillageID, avoidNatives);
		// rmAddGroupingConstraint(comanche2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comanche2VillageID, 0, 0.25, 0.45);
	} 
	
	    if (subCiv2 == rmGetCivID("Comanche"))
	{  
		int comanche3VillageID = -1;
		comanche3VillageID = rmCreateGrouping("comanche village 3", "native comanche village 1");
		rmSetGroupingMinDistance(comanche3VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche3VillageID, 0.0);
		// rmAddGroupingConstraint(comanche3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(comanche3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche3VillageID, avoidNatives);
		// rmAddGroupingConstraint(comanche3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comanche3VillageID, 0, 0.55, 0.75);
	} 

	    if (subCiv3 == rmGetCivID("Comanche"))
	{  
		int comanche4VillageID = -1;
		comanche4VillageID = rmCreateGrouping("comanche village 4", "native comanche village 1");
		rmSetGroupingMinDistance(comanche4VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche4VillageID, 0.0);
		// rmAddGroupingConstraint(comanche4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(comanche4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche4VillageID, avoidNatives);
		// rmAddGroupingConstraint(comanche4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comanche4VillageID, 0, 0.75, 0.55);
	} 
	    

	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************** TWO EXTRA SILVER MINES IN THE SPOTS WHERE THE NATIVES AREN'T: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE GOLD COIN WEST: ************************************ //
/*================================================================================================================*/
    int playerCoinsW1ID=rmCreateObjectDef("player CoinsW1");
    rmAddObjectDefItem(playerCoinsW1ID, "minegold", 1, 0.0);
    rmSetObjectDefMinDistance(playerCoinsW1ID, 0.0);
    rmSetObjectDefMaxDistance(playerCoinsW1ID, 0.0);
    rmAddObjectDefConstraint(playerCoinsW1ID, avoidGold);
    rmAddObjectDefConstraint(playerCoinsW1ID, goldAvoidGold);
    rmPlaceObjectDefAtLoc(playerCoinsW1ID, 0, 0.25, 0.55);
    rmPlaceObjectDefAtLoc(playerCoinsW1ID, 0, 0.45, 0.75);	
	rmPlaceObjectDefAtLoc(playerCoinsW1ID, 0, 0.25, 0.75);	
/*----------------------------------------------------------------------------------------------------------------*/	
	int playerCoinsE2ID=rmCreateObjectDef("player CoinsE2");
    rmAddObjectDefItem(playerCoinsE2ID, "minegold", 1, 0.0);
    rmSetObjectDefMinDistance(playerCoinsE2ID, 0.0);
    rmSetObjectDefMaxDistance(playerCoinsE2ID, 0.0);
    rmAddObjectDefConstraint(playerCoinsE2ID, avoidGold);
    rmAddObjectDefConstraint(playerCoinsE2ID, goldAvoidGold);
    rmPlaceObjectDefAtLoc(playerCoinsE2ID, 0, 0.55, 0.25); 
    rmPlaceObjectDefAtLoc(playerCoinsE2ID, 0, 0.75, 0.45);
	rmPlaceObjectDefAtLoc(playerCoinsE2ID, 0, 0.75, 0.25);
/*================================================================================================================*/
    int playerCoinsN1ID=rmCreateObjectDef("player CoinsN1");
    rmAddObjectDefItem(playerCoinsN1ID, "minegold", 1, 0.0);
    rmSetObjectDefMinDistance(playerCoinsN1ID, 0.0);
    rmSetObjectDefMaxDistance(playerCoinsN1ID, 0.0);
    rmAddObjectDefConstraint(playerCoinsN1ID, avoidGold);
    rmAddObjectDefConstraint(playerCoinsN1ID, goldAvoidGold);
    rmPlaceObjectDefAtLoc(playerCoinsN1ID, 0, 0.65, 0.85);
    rmPlaceObjectDefAtLoc(playerCoinsN1ID, 0, 0.85, 0.65);	
/*----------------------------------------------------------------------------------------------------------------*/
    int playerCoinsS1ID=rmCreateObjectDef("player CoinsS1");
    rmAddObjectDefItem(playerCoinsS1ID, "minegold", 1, 0.0);
    rmSetObjectDefMinDistance(playerCoinsS1ID, 0.0);
    rmSetObjectDefMaxDistance(playerCoinsS1ID, 0.0);
    rmAddObjectDefConstraint(playerCoinsS1ID, avoidGold);
    rmAddObjectDefConstraint(playerCoinsS1ID, goldAvoidGold);
    rmPlaceObjectDefAtLoc(playerCoinsS1ID, 0, 0.15, 0.35);
    rmPlaceObjectDefAtLoc(playerCoinsS1ID, 0, 0.35, 0.15);	
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE CLIFFS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************** PLACE SOME EXTRA SMALL-ISH PRONGHORN HERDS: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int BisonsW1ID=rmCreateObjectDef("The BisonsW1");
    rmAddObjectDefItem(BisonsW1ID, "bison", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(BisonsW1ID, 0.0);
    rmSetObjectDefMaxDistance(BisonsW1ID, 0.0);
    rmAddObjectDefConstraint(BisonsW1ID, avoidBison);
    rmAddObjectDefConstraint(BisonsW1ID, bisonAvoidBison);
    rmPlaceObjectDefAtLoc(BisonsW1ID, 0, 0.1, 0.6);
    rmPlaceObjectDefAtLoc(BisonsW1ID, 0, 0.25, 0.85);
	rmPlaceObjectDefAtLoc(BisonsW1ID, 0, 0.45, 0.95);
/*----------------------------------------------------------------------------------------------------------------*/
    int BisonsE1ID=rmCreateObjectDef("The BisonsE1");
    rmAddObjectDefItem(BisonsE1ID, "bison", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(BisonsE1ID, 0.0);
    rmSetObjectDefMaxDistance(BisonsE1ID, 0.0);
    rmAddObjectDefConstraint(BisonsE1ID, avoidBison);
    rmAddObjectDefConstraint(BisonsE1ID, bisonAvoidBison);
    rmPlaceObjectDefAtLoc(BisonsE1ID, 0, 0.6, 0.1);
    rmPlaceObjectDefAtLoc(BisonsE1ID, 0, 0.85, 0.25);
    rmPlaceObjectDefAtLoc(BisonsE1ID, 0, 0.95, 0.45); 
/*================================================================================================================*/
    int playerNuggetW1ID=rmCreateObjectDef("player nugget W1 ");
    rmAddObjectDefItem(playerNuggetW1ID, "nugget", 1, 0.0);
    rmAddObjectDefToClass(playerNuggetW1ID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetW1ID, 0.0);
    rmSetObjectDefMaxDistance(playerNuggetW1ID, 0.0);
    rmAddObjectDefConstraint(playerNuggetW1ID, avoidNugget);
    rmAddObjectDefConstraint(playerNuggetW1ID, nuggetAvoidNugget);
    rmPlaceObjectDefAtLoc(playerNuggetW1ID, 0, 0.125, 0.75);
	rmPlaceObjectDefAtLoc(playerNuggetW1ID, 0, 0.325, 0.925);
	rmPlaceObjectDefAtLoc(playerNuggetW1ID, 0, 0.525, 0.975);
	rmPlaceObjectDefAtLoc(playerNuggetW1ID, 0, 0.05, 0.525);
/*----------------------------------------------------------------------------------------------------------------*/   
    int playerNuggetE2ID=rmCreateObjectDef("player nugget E2 ");
    rmAddObjectDefItem(playerNuggetE2ID, "nugget", 1, 0.0);
    rmAddObjectDefToClass(playerNuggetE2ID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetE2ID, 0.0);
    rmSetObjectDefMaxDistance(playerNuggetE2ID, 0.0);
    rmAddObjectDefConstraint(playerNuggetE2ID, avoidNugget);
    rmAddObjectDefConstraint(playerNuggetE2ID, nuggetAvoidNugget);
    rmPlaceObjectDefAtLoc(playerNuggetE2ID, 0, 0.75, 0.125);
    rmPlaceObjectDefAtLoc(playerNuggetE2ID, 0, 0.925, 0.325);
    rmPlaceObjectDefAtLoc(playerNuggetE2ID, 0, 0.975, 0.525);	
    rmPlaceObjectDefAtLoc(playerNuggetE2ID, 0, 0.525, 0.05);
/*================================================================================================================*/
    int playerNuggetN1ID=rmCreateObjectDef("player nugget N1 ");
    rmAddObjectDefItem(playerNuggetN1ID, "nugget", 1, 0.0);
    rmAddObjectDefToClass(playerNuggetN1ID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetN1ID, 0.0);
    rmSetObjectDefMaxDistance(playerNuggetN1ID, 0.0);
    rmAddObjectDefConstraint(playerNuggetN1ID, avoidNugget);
    rmAddObjectDefConstraint(playerNuggetN1ID, nuggetAvoidNugget);
    rmPlaceObjectDefAtLoc(playerNuggetN1ID, 0, 0.6, 0.7);
	rmPlaceObjectDefAtLoc(playerNuggetN1ID, 0, 0.7, 0.6);
/*----------------------------------------------------------------------------------------------------------------*/
    int playerNuggetS1ID=rmCreateObjectDef("player nugget S1 ");
    rmAddObjectDefItem(playerNuggetS1ID, "nugget", 1, 0.0);
    rmAddObjectDefToClass(playerNuggetS1ID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetS1ID, 0.0);
    rmSetObjectDefMaxDistance(playerNuggetS1ID, 0.0);
    rmAddObjectDefConstraint(playerNuggetS1ID, avoidNugget);
    rmAddObjectDefConstraint(playerNuggetS1ID, nuggetAvoidNugget);
    rmPlaceObjectDefAtLoc(playerNuggetS1ID, 0, 0.3, 0.4);
	rmPlaceObjectDefAtLoc(playerNuggetS1ID, 0, 0.4, 0.3);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEER: ******************************************* //
/*================================================================================================================*/
    int DeersW1ID=rmCreateObjectDef("The DeersW1");
    rmAddObjectDefItem(DeersW1ID, "deer", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(DeersW1ID, 0.0);
    rmSetObjectDefMaxDistance(DeersW1ID, 0.0);
    rmAddObjectDefConstraint(DeersW1ID, avoidDeer);
    rmAddObjectDefConstraint(DeersW1ID, deerAvoidDeer);
    rmPlaceObjectDefAtLoc(DeersW1ID, 0, 0.3, 0.6);
    rmPlaceObjectDefAtLoc(DeersW1ID, 0, 0.4, 0.7);
/*----------------------------------------------------------------------------------------------------------------*/
    int DeersE1ID=rmCreateObjectDef("The DeersE1");
    rmAddObjectDefItem(DeersE1ID, "deer", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(DeersE1ID, 0.0);
    rmSetObjectDefMaxDistance(DeersE1ID, 0.0);
    rmAddObjectDefConstraint(DeersE1ID, avoidDeer);
    rmAddObjectDefConstraint(DeersE1ID, deerAvoidDeer);
    rmPlaceObjectDefAtLoc(DeersE1ID, 0, 0.6, 0.3);
    rmPlaceObjectDefAtLoc(DeersE1ID, 0, 0.7, 0.4);
/*----------------------------------------------------------------------------------------------------------------*/
    int DeersN1ID=rmCreateObjectDef("The DeersN1");
    rmAddObjectDefItem(DeersN1ID, "deer", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(DeersN1ID, 0.0);
    rmSetObjectDefMaxDistance(DeersN1ID, 0.0);
    rmAddObjectDefConstraint(DeersN1ID, avoidDeer);
    rmAddObjectDefConstraint(DeersN1ID, deerAvoidDeer);
    rmPlaceObjectDefAtLoc(DeersN1ID, 0, 0.65, 0.65);
/*----------------------------------------------------------------------------------------------------------------*/
    int DeersS1ID=rmCreateObjectDef("The DeersS1");
    rmAddObjectDefItem(DeersS1ID, "deer", rmRandInt(8,10), 6.0);
    rmSetObjectDefMinDistance(DeersS1ID, 0.0);
    rmSetObjectDefMaxDistance(DeersS1ID, 0.0);
    rmAddObjectDefConstraint(DeersS1ID, avoidDeer);
    rmAddObjectDefConstraint(DeersS1ID, deerAvoidDeer);
    rmPlaceObjectDefAtLoc(DeersS1ID, 0, 0.35, 0.35);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE COW: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int cowID=rmCreateObjectDef("cow");
        rmAddObjectDefItem(cowID, "cow", 5, 5.0);
        rmSetObjectDefMinDistance(cowID, 0.0);
        rmSetObjectDefMaxDistance(cowID, 0.0);
        rmAddObjectDefConstraint(cowID, avoidCow);
		rmAddObjectDefConstraint(cowID, cowAvoidCow);
	    rmAddObjectDefConstraint(cowID, avoidRegion);
	    rmAddObjectDefConstraint(cowID, avoidRegion2);
	    //rmAddObjectDefConstraint(cowID, avoidCliffs);
        rmAddObjectDefConstraint(cowID, avoidImpassableLand);
	    rmPlaceObjectDefAtLoc(cowID, 0, 0.1, 0.4);
        rmPlaceObjectDefAtLoc(cowID, 0, 0.4, 0.1);
        rmPlaceObjectDefAtLoc(cowID, 0, 0.7, 0.9);
        rmPlaceObjectDefAtLoc(cowID, 0, 0.9, 0.7);
        rmPlaceObjectDefAtLoc(cowID, 0, 0.35, 0.65);
        rmPlaceObjectDefAtLoc(cowID, 0, 0.65, 0.35);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES: ****************************************** //
/*================================================================================================================*/
    int BerriesW1ID=rmCreateObjectDef("The BerriesW1");
    rmAddObjectDefItem(BerriesW1ID, "berrybush", rmRandInt(3,5), 6.0);
    rmSetObjectDefMinDistance(BerriesW1ID, 0.0);
    rmSetObjectDefMaxDistance(BerriesW1ID, 0.0);
    rmAddObjectDefConstraint(BerriesW1ID, avoidFruit);
    rmAddObjectDefConstraint(BerriesW1ID, fruitAvoidFruit);
    rmPlaceObjectDefAtLoc(BerriesW1ID, 0, 0.125, 0.225);
    rmPlaceObjectDefAtLoc(BerriesW1ID, 0, 0.775, 0.875);	
/*================================================================================================================*/
    int BerriesE1ID=rmCreateObjectDef("The BerriesE1");
    rmAddObjectDefItem(BerriesE1ID, "berrybush", rmRandInt(3,5), 6.0);
    rmSetObjectDefMinDistance(BerriesE1ID, 0.0);
    rmSetObjectDefMaxDistance(BerriesE1ID, 0.0);
    rmAddObjectDefConstraint(BerriesE1ID, avoidFruit);
    rmAddObjectDefConstraint(BerriesE1ID, fruitAvoidFruit);
    rmPlaceObjectDefAtLoc(BerriesE1ID, 0, 0.225, 0.125);
    rmPlaceObjectDefAtLoc(BerriesE1ID, 0, 0.875, 0.775);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE BIG DECORATIVE THINGS: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
	
	rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.6, 0.2); 	
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.2, 0.6); 	
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.8, 0.5); 	
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.8); 
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE PERCHING VULTURES: ************************************* //
/*================================================================================================================*/
	int vultureID=rmCreateObjectDef("perching vultures");
	int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	
	rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	rmSetObjectDefMinDistance(vultureID, 0.0);
	rmSetObjectDefMaxDistance(vultureID, 0.0);
	rmAddObjectDefConstraint(vultureID, avoidVultures);
	
	rmPlaceObjectDefAtLoc(vultureID, 0, 0.2, 0.4);
    rmPlaceObjectDefAtLoc(vultureID, 0, 0.4, 0.2);
    rmPlaceObjectDefAtLoc(vultureID, 0, 0.2, 0.8);
    rmPlaceObjectDefAtLoc(vultureID, 0, 0.8, 0.2);
    rmPlaceObjectDefAtLoc(vultureID, 0, 0.6, 0.8);	
    rmPlaceObjectDefAtLoc(vultureID, 0, 0.8, 0.6);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE FORESTS _ NORTH AND SOUTH: ****************************** //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	        int forestTreeID = 0;
	
	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(westForest, "texas forest dirt");
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			//rmAddAreaConstraint(westForest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(westForest, avoidCoin);
			rmAddAreaConstraint(westForest, avoidCow);
			rmAddAreaConstraint(westForest, avoidNugget);	
			//rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(westForest, Westward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(westForest, avoidGold);
			rmAddAreaConstraint(westForest, avoidNatives);	
			//rmAddAreaConstraint(westForest, avoidCliffs);
			//rmAddAreaConstraint(westForest, forestsAvoidBison);
			rmSetAreaLocation(westForest, 0.90, 0.55);
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
             numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west2Forest=rmCreateArea("west2Forest"+i);
			rmSetAreaWarnFailure(west2Forest, false);
			rmSetAreaSize(west2Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(west2Forest, "texas forest dirt");
			rmSetAreaForestDensity(west2Forest, 0.7);
			rmSetAreaForestClumpiness(west2Forest, 0.4);
			rmSetAreaForestUnderbrush(west2Forest, 0.0);
			rmSetAreaMinBlobs(west2Forest, 1);
			rmSetAreaMaxBlobs(west2Forest, 3);
			rmSetAreaMinBlobDistance(west2Forest, 5.0);
			rmSetAreaMaxBlobDistance(west2Forest, 20.0);
			rmSetAreaCoherence(west2Forest, 0.4);
			rmSetAreaSmoothDistance(west2Forest, 10);
			//rmAddAreaConstraint(west2Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west2Forest, avoidCoin);
			rmAddAreaConstraint(west2Forest, avoidCow);
			rmAddAreaConstraint(west2Forest, avoidNugget);	
			//rmAddAreaConstraint(west2Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(west2Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(west2Forest, Westward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(west2Forest, avoidGold);
			rmAddAreaConstraint(west2Forest, avoidNatives);	
			//rmAddAreaConstraint(west2Forest, avoidCliffs);
			//rmAddAreaConstraint(west2Forest, forestsAvoidBison);
			rmSetAreaLocation(west2Forest, 0.35, 0.85);
			if(rmBuildArea(west2Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west3Forest=rmCreateArea("west3Forest"+i);
			rmSetAreaWarnFailure(west3Forest, false);
			rmSetAreaSize(west3Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(west3Forest, "texas forest dirt");
			rmSetAreaForestDensity(west3Forest, 0.7);
			rmSetAreaForestClumpiness(west3Forest, 0.4);
			rmSetAreaForestUnderbrush(west3Forest, 0.0);
			rmSetAreaMinBlobs(west3Forest, 1);
			rmSetAreaMaxBlobs(west3Forest, 3);
			rmSetAreaMinBlobDistance(west3Forest, 5.0);
			rmSetAreaMaxBlobDistance(west3Forest, 20.0);
			rmSetAreaCoherence(west3Forest, 0.4);
			rmSetAreaSmoothDistance(west3Forest, 10);
			//rmAddAreaConstraint(west3Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west3Forest, avoidCoin);
			rmAddAreaConstraint(west3Forest, avoidCow);
			rmAddAreaConstraint(west3Forest, avoidNugget);	
			//rmAddAreaConstraint(west3Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(west3Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(west3Forest, Westward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(west3Forest, avoidGold);
			rmAddAreaConstraint(west3Forest, avoidNatives);	
			//rmAddAreaConstraint(west3Forest, avoidCliffs);
			//rmAddAreaConstraint(west3Forest, forestsAvoidBison);
			rmSetAreaLocation(west3Forest, 0.20, 0.70);
			if(rmBuildArea(west3Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int west4Forest=rmCreateArea("west4Forest"+i);
			rmSetAreaWarnFailure(west4Forest, false);
			rmSetAreaSize(west4Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(west4Forest, "texas forest dirt");
			rmSetAreaForestDensity(west4Forest, 0.7);
			rmSetAreaForestClumpiness(west4Forest, 0.4);
			rmSetAreaForestUnderbrush(west4Forest, 0.0);
			rmSetAreaMinBlobs(west4Forest, 1);
			rmSetAreaMaxBlobs(west4Forest, 3);
			rmSetAreaMinBlobDistance(west4Forest, 5.0);
			rmSetAreaMaxBlobDistance(west4Forest, 20.0);
			rmSetAreaCoherence(west4Forest, 0.4);
			rmSetAreaSmoothDistance(west4Forest, 10);
			//rmAddAreaConstraint(west4Forest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(west4Forest, avoidCoin);
			rmAddAreaConstraint(west4Forest, avoidCow);
			rmAddAreaConstraint(west4Forest, avoidNugget);	
			//rmAddAreaConstraint(west4Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(west4Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(west4Forest, Westward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(west4Forest, avoidGold);
			rmAddAreaConstraint(west4Forest, avoidNatives);	
			//rmAddAreaConstraint(west4Forest, avoidCliffs);
			//rmAddAreaConstraint(west4Forest, forestsAvoidBison);
			rmSetAreaLocation(west4Forest, 0.15, 0.50);
			if(rmBuildArea(west4Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}		
		
/*================================================================================================================*/

	        numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			rmSetAreaSize(eastForest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(eastForest, "texas forest dirt");
			rmSetAreaForestDensity(eastForest, 0.7);
			rmSetAreaForestClumpiness(eastForest, 0.4);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 3);
			rmSetAreaMinBlobDistance(eastForest, 5.0);
			rmSetAreaMaxBlobDistance(eastForest, 20.0);
			rmSetAreaCoherence(eastForest, 0.4);
			rmSetAreaSmoothDistance(eastForest, 10);
			//rmAddAreaConstraint(eastForest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(eastForest, avoidCoin);
			rmAddAreaConstraint(eastForest, avoidCow);
			rmAddAreaConstraint(eastForest, avoidNugget);	
			//rmAddAreaConstraint(eastForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(eastForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(eastForest, Eastward);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(eastForest, avoidGold);
			rmAddAreaConstraint(eastForest, avoidNatives);	
			//rmAddAreaConstraint(eastForest, avoidCliffs);
			//rmAddAreaConstraint(eastForest, forestsAvoidBison);
			rmSetAreaLocation(eastForest, 0.55, 0.90);
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int east2Forest=rmCreateArea("east2Forest"+i);
			rmSetAreaWarnFailure(east2Forest, false);
			rmSetAreaSize(east2Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(east2Forest, "texas forest dirt");
			rmSetAreaForestDensity(east2Forest, 0.7);
			rmSetAreaForestClumpiness(east2Forest, 0.4);
			rmSetAreaForestUnderbrush(east2Forest, 0.0);
			rmSetAreaMinBlobs(east2Forest, 1);
			rmSetAreaMaxBlobs(east2Forest, 3);
			rmSetAreaMinBlobDistance(east2Forest, 5.0);
			rmSetAreaMaxBlobDistance(east2Forest, 20.0);
			rmSetAreaCoherence(east2Forest, 0.4);
			rmSetAreaSmoothDistance(east2Forest, 10);
			//rmAddAreaConstraint(east2Forest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(east2Forest, avoidCoin);
			rmAddAreaConstraint(east2Forest, avoidCow);
			rmAddAreaConstraint(east2Forest, avoidNugget);	
			//rmAddAreaConstraint(east2Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(east2Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(east2Forest, Eastward);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(east2Forest, avoidGold);
			rmAddAreaConstraint(east2Forest, avoidNatives);	
			//rmAddAreaConstraint(east2Forest, avoidCliffs);
			//rmAddAreaConstraint(east2Forest, forestsAvoidBison);
			rmSetAreaLocation(east2Forest, 0.85, 0.35);
			if(rmBuildArea(east2Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int east3Forest=rmCreateArea("east3Forest"+i);
			rmSetAreaWarnFailure(east3Forest, false);
			rmSetAreaSize(east3Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(east3Forest, "texas forest dirt");
			rmSetAreaForestDensity(east3Forest, 0.7);
			rmSetAreaForestClumpiness(east3Forest, 0.4);
			rmSetAreaForestUnderbrush(east3Forest, 0.0);
			rmSetAreaMinBlobs(east3Forest, 1);
			rmSetAreaMaxBlobs(east3Forest, 3);
			rmSetAreaMinBlobDistance(east3Forest, 5.0);
			rmSetAreaMaxBlobDistance(east3Forest, 20.0);
			rmSetAreaCoherence(east3Forest, 0.4);
			rmSetAreaSmoothDistance(east3Forest, 10);
			//rmAddAreaConstraint(east3Forest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(east3Forest, avoidCoin);
			rmAddAreaConstraint(east3Forest, avoidCow);
			rmAddAreaConstraint(east3Forest, avoidNugget);	
			//rmAddAreaConstraint(east3Forest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(east3Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			//rmAddAreaConstraint(east3Forest, Eastward);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(east3Forest, avoidGold);
			rmAddAreaConstraint(east3Forest, avoidNatives);	
			//rmAddAreaConstraint(east3Forest, avoidCliffs);
			//rmAddAreaConstraint(east3Forest, forestsAvoidBison);
			rmSetAreaLocation(east3Forest, 0.70, 0.20);
			if(rmBuildArea(east3Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int east4Forest=rmCreateArea("east4Forest"+i);
			rmSetAreaWarnFailure(east4Forest, false);
			rmSetAreaSize(east4Forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(east4Forest, "texas forest dirt");
			rmSetAreaForestDensity(east4Forest, 0.7);
			rmSetAreaForestClumpiness(east4Forest, 0.4);
			rmSetAreaForestUnderbrush(east4Forest, 0.0);
			rmSetAreaMinBlobs(east4Forest, 1);
			rmSetAreaMaxBlobs(east4Forest, 3);
			rmSetAreaMinBlobDistance(east4Forest, 5.0);
			rmSetAreaMaxBlobDistance(east4Forest, 20.0);
			rmSetAreaCoherence(east4Forest, 0.4);
			rmSetAreaSmoothDistance(east4Forest, 10);
			//rmAddAreaConstraint(east4Forest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			//rmAddAreaConstraint(east4Forest, avoidCoin);
			rmAddAreaConstraint(east4Forest, avoidNugget);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(east4Forest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(east4Forest, avoidNatives);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(east4Forest, avoidGold);
			rmAddAreaConstraint(east4Forest, avoidCow);
			//rmAddAreaConstraint(east4Forest, forestsAvoidBison);
			rmSetAreaLocation(east4Forest, 0.50, 0.15);
			if(rmBuildArea(east4Forest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}  
/*================================================================================================================*/
            numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int centerForest=rmCreateArea("centerForest"+i);
			rmSetAreaWarnFailure(centerForest, false);
			// rmSetAreaSize(centerForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			   // rmSetAreaSize(centerForest, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
			rmSetAreaSize(centerForest, 0.05, 0.05);	   
			rmSetAreaForestType(centerForest, "texas forest dirt");
			rmSetAreaForestDensity(centerForest, 0.7);
			rmSetAreaForestClumpiness(centerForest, 0.4);
			rmSetAreaForestUnderbrush(centerForest, 0.0);
			rmSetAreaMinBlobs(centerForest, 1);
			rmSetAreaMaxBlobs(centerForest, 1);
			rmSetAreaMinBlobDistance(centerForest, 1.0);
			rmSetAreaMaxBlobDistance(centerForest, 1.0);
			rmSetAreaCoherence(centerForest, 0.4);
			rmSetAreaSmoothDistance(centerForest, 10);
			rmAddAreaConstraint(centerForest, avoidDeer);
			//rmAddAreaConstraint(centerForest, avoidCoin);
			rmAddAreaConstraint(centerForest, avoidNugget);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(centerForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(centerForest, avoidNatives);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(centerForest, avoidGold);
			rmAddAreaConstraint(centerForest, avoidCow);
			//rmAddAreaConstraint(centerForest, forestsAvoidBison);
			rmSetAreaLocation(centerForest, 0.50, 0.50);
			if(rmBuildArea(centerForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}  		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE MORE COIN IN THE MIDDLE: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE COW: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
       	
/*================================================================================================================*/
// ********************************** PERCHING VULTURES - ADD FOUR SOMEWHERE: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
} 
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/ 
